<!DOCTYPE html>
<html>
  <body style="font-family: Arial, sans-serif; padding: 20px">
    <h1 style="text-align: center; margin-bottom: 20px">Balanced Bracket</h1>
    <div style="display: flex; justify-content: center">
      <div>
        <div style="margin-bottom: 20px">
          <label
            for="stringInput"
            style="width: 230px; display: inline-block; text-align: right"
            >Input bracket:</label
          >
          <input
            type="text"
            id="stringInput"
            style="
              margin-left: 10px;
              height: 34px;
              border: 1px solid #d3d3d3;
              padding: 0 10px;
              border-radius: 4px;
            "
          />
        </div>
        <div style="margin-bottom: 20px">
          <label
            for="queryInput"
            style="width: 230px; display: inline-block; text-align: right"
          >
          </label>
          <button onclick="runBalancedBracket()" style="padding: 10px">
            Result
          </button>
        </div>

        <div
          id="result"
          style="
            margin-top: 20px;
            width: 500px;
            background-color: #efefef;
            border: 1px solid #d3d3d3;
            border-radius: 4px;
            text-align: center;
            height: 50px;
            line-height: 50px;
          "
        ></div>
      </div>
    </div>

    <script>
      function isBalanced(expression) {
        let stack = [];

        for (let i = 0; i < expression.length; i++) {
          let currentChar = expression[i];

          if (
            currentChar === "(" ||
            currentChar === "{" ||
            currentChar === "["
          ) {
            stack.push(currentChar);
          } else if (
            currentChar === ")" ||
            currentChar === "}" ||
            currentChar === "]"
          ) {
            if (stack.length === 0) {
              return "NO";
            }

            let top = stack.pop();

            if (
              (currentChar === ")" && top !== "(") ||
              (currentChar === "}" && top !== "{") ||
              (currentChar === "]" && top !== "[")
            ) {
              return "NO";
            }
          }
        }

        if (stack.length !== 0) {
          return "NO";
        }

        return "YES";
      }

      function runBalancedBracket() {
        let expression = document.getElementById("stringInput").value;
        let result = isBalanced(expression);

        document.getElementById("result").innerText = result;
      }
    </script>
  </body>
</html>
